using System;
using System.Runtime.InteropServices;
using PkmnLibSharp.Utilities;

namespace PkmnLibSharp.Battling.Events
{
    public class CaptureAttemptEvent : EventData
    {

        private Pokemon? _pokemon;
        private CaptureLibrary.CaptureResult? _result;

        internal CaptureAttemptEvent(EventDataKind kind, IntPtr ptr) : base(kind, ptr)
        {
        }

        public Pokemon Pokemon
        {
            get
            {
                if (_pokemon != null) return _pokemon;
                var ptr = Pkmnlib.Generated.CaptureAttemptEvent.GetPokemon(Ptr);
                if (TryResolvePointer(ptr, out _pokemon))
                    return _pokemon!;
                _pokemon = Constructor.Active.ConstructPokemon(ptr)!;
                return _pokemon;
            }
        }


        public CaptureLibrary.CaptureResult Result
        {
            get
            {
                if (_result != null) return _result.Value;
                var p = Pkmnlib.Generated.CaptureAttemptEvent.GetResult(Ptr);
                _result = Marshal.PtrToStructure<CaptureLibrary.CaptureResult>(p);
                return _result.Value;
            }
        }

        protected override void DeletePtr()
        {
            Pkmnlib.Generated.CaptureAttemptEvent.Destruct(Ptr);
        }
    }
}